/*
Marcin Owsiany 8:00
4 7.12.2000
6 18
*/

#include "msg.h"
#include "fifo.h"
#include "msgq.h"
#include "shmmsg.h"
#include "interface.h"
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#define MY_FIFO "fifo"
char *fifo = MY_FIFO;

int key = KEY;

void wrmode(int mode)
{
	printf("Wrong mode %d!\n", mode);
	exit(EXIT_FAILURE);
}

int client_init(int mode)
{
	if (mode == FIFO) {
		return client_fifo_init(fifo);
	} else if (mode == MSGQ) {
		return client_msgq_init(key);
	} else if (mode == SHM) {
		return client_shmmsgq_init(key);
	}
	wrmode(mode);
	return 0;
}

int server_init(int mode)
{
	if (mode == FIFO) {
		return server_fifo_init(fifo);
	} else if (mode == MSGQ) {
		return server_msgq_init(key);
	} else if (mode == SHM) {
		return server_shmmsgq_init(key);
	}
	wrmode(mode);
	return 0;
}

int my_msgsnd(int fd, struct my_msgbuf *msg, int n, int mode)
{
	if (mode == FIFO) {
		return fifo_msgsnd(fd, msg, n);
	} else if (mode == MSGQ) {
		return msgq_msgsnd(fd, msg, n);
	} else if (mode == SHM) {
		return shmmsgq_msgsnd(fd, msg, n);
	}
	wrmode(mode);
	return 0;
}

int my_msgrecv(int fd, struct my_msgbuf *msg, int n, int mode)
{
	if (mode == FIFO) {
		return fifo_msgrecv(fd, msg, n);
	} else if (mode == MSGQ) {
		return msgq_msgrecv(fd, msg, n);
	} else if (mode == SHM) {
		return shmmsgq_msgrecv(fd, msg, n);
	}
	wrmode(mode);
	return 0;
}

int my_close(int fd, int mode)
{
	if (mode == FIFO) {
		return fifo_close(fd);
	} else if (mode == MSGQ) {
		return msgq_close(fd);
	} else if (mode == SHM) {
		return shmmsgq_close(fd);
	}
	wrmode(mode);
	return 0;
}
