/*
Marcin Owsiany 8:00
4 7.12.2000
17 18
*/

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include "msgq.h"
#include "shmmsg.h"
#include "myshm.h"

extern int errno;

int client_shmmsgq_init(key_t key)
{
	int n;
	if ((n = shm_msgget(key, IPC_CREAT | 0666)) == -1) {
		printf("tam\n");
		perror("msgget()");
		exit(EXIT_FAILURE);
	} else
		return n;
}

int server_shmmsgq_init(key_t key)
{
	int n;
	if ((n = shm_msgget(key, IPC_CREAT | 0666)) == -1) {
		printf("tu\n");
		perror("msgget()");
		exit(EXIT_FAILURE);
	} else
		return n;
}

int shmmsgq_msgsnd(int id, struct my_msgbuf *msg, int n)
{
	if (shm_msgsnd(id, msg, n, 0) != 0) {
		perror("msgsnd() failed");
		msgq_close(id);
		exit(EXIT_FAILURE);
	} else
		return n;
}

int shmmsgq_msgrecv(int id, struct my_msgbuf *msg, int n)
{
	int k;
	if ((k = shm_msgrcv(id, msg, n, msg->mtype, 0)) != n) {
		fprintf(stderr, "msgrcv for %d bytes got %d bytes\n", n, k);
		perror("msgrecv()");
		msgq_close(id);
		exit(EXIT_FAILURE);
	} else
		return n;
}

int shmmsgq_close(int id)
{
	return shm_msgctl(id, IPC_RMID, NULL);
}
